<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleInfoOnDateItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleInfoOnDateItem extends AbstractStructArrayBase
{
    /**
     * The VehicleInfoOnDateItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleInfoOnDateItem[]
     */
    public $VehicleInfoOnDateItem;
    /**
     * Constructor method for ArrayOfVehicleInfoOnDateItem
     * @uses ArrayOfVehicleInfoOnDateItem::setVehicleInfoOnDateItem()
     * @param \StructType\VehicleInfoOnDateItem[] $vehicleInfoOnDateItem
     */
    public function __construct(array $vehicleInfoOnDateItem = array())
    {
        $this
            ->setVehicleInfoOnDateItem($vehicleInfoOnDateItem);
    }
    /**
     * Get VehicleInfoOnDateItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleInfoOnDateItem[]|null
     */
    public function getVehicleInfoOnDateItem()
    {
        return isset($this->VehicleInfoOnDateItem) ? $this->VehicleInfoOnDateItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVehicleInfoOnDateItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVehicleInfoOnDateItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVehicleInfoOnDateItemForArrayConstraintsFromSetVehicleInfoOnDateItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVehicleInfoOnDateItemVehicleInfoOnDateItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleInfoOnDateItemVehicleInfoOnDateItemItem instanceof \StructType\VehicleInfoOnDateItem) {
                $invalidValues[] = is_object($arrayOfVehicleInfoOnDateItemVehicleInfoOnDateItemItem) ? get_class($arrayOfVehicleInfoOnDateItemVehicleInfoOnDateItemItem) : sprintf('%s(%s)', gettype($arrayOfVehicleInfoOnDateItemVehicleInfoOnDateItemItem), var_export($arrayOfVehicleInfoOnDateItemVehicleInfoOnDateItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VehicleInfoOnDateItem property can only contain items of type \StructType\VehicleInfoOnDateItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VehicleInfoOnDateItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleInfoOnDateItem[] $vehicleInfoOnDateItem
     * @return \ArrayType\ArrayOfVehicleInfoOnDateItem
     */
    public function setVehicleInfoOnDateItem(array $vehicleInfoOnDateItem = array())
    {
        // validation for constraint: array
        if ('' !== ($vehicleInfoOnDateItemArrayErrorMessage = self::validateVehicleInfoOnDateItemForArrayConstraintsFromSetVehicleInfoOnDateItem($vehicleInfoOnDateItem))) {
            throw new \InvalidArgumentException($vehicleInfoOnDateItemArrayErrorMessage, __LINE__);
        }
        if (is_null($vehicleInfoOnDateItem) || (is_array($vehicleInfoOnDateItem) && empty($vehicleInfoOnDateItem))) {
            unset($this->VehicleInfoOnDateItem);
        } else {
            $this->VehicleInfoOnDateItem = $vehicleInfoOnDateItem;
        }
        return $this;
    }
    /**
     * Add item to VehicleInfoOnDateItem value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleInfoOnDateItem $item
     * @return \ArrayType\ArrayOfVehicleInfoOnDateItem
     */
    public function addToVehicleInfoOnDateItem(\StructType\VehicleInfoOnDateItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleInfoOnDateItem) {
            throw new \InvalidArgumentException(sprintf('The VehicleInfoOnDateItem property can only contain items of type \StructType\VehicleInfoOnDateItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VehicleInfoOnDateItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleInfoOnDateItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleInfoOnDateItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleInfoOnDateItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleInfoOnDateItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleInfoOnDateItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleInfoOnDateItem
     */
    public function getAttributeName()
    {
        return 'VehicleInfoOnDateItem';
    }
}
